
User Interface - Feature #2563

Feature # 2252 (Closed): implement GUI client support

implement GUI EDITOR widget

04/30/2015 01:07 PM - Greg Shah

Status: Closed Start date: 04/30/2015

Priority: Normal Due date:  

Assignee: Constantin Asofiei % Done: 0%

Category:  Estimated time: 0.00 hour

Target version: GUI Support for a Complex ADM2 App   

billable: No vendor_id: GCD

Description

Related issues:

Related to User Interface - Feature #2534: methods/attrs support for EDITOR, ... Closed 03/06/2015

History

#1 - 04/30/2015 01:11 PM - Greg Shah

Please note that MAX-CHARS, RETURN-INSERTED and WORD-WRAP are attributes which need to be implemented as part of this task.  They were

investigated in #2534.  Conversion support and server-side runtime support (setting/getting config values) is already implemented for

RETURN-INSERTED.  MAX-CHARS and WORD-WRAP are not there yet.

All 3 need client-side implementation as part of the GUI widget implementation.  They are GUI-only features.

#2 - 05/09/2015 03:52 PM - Constantin Asofiei

- File ca_upd20150509b.zip added

- Status changed from New to WIP

First candidate version for a usable EDITOR in GUI.  Basic keys (cursor movement, home/end, delete/backspace, text editing) seem to work OK with

or without scrollbars.  The widget is responsive to mouse events, too.

The current approach is to use the same pseudo-scrolling support as used by ChUI - the scrollbars, although refreshed when the caret moves, do not

work OK with the mouse.  The headache will be to adjust this to work properly via scrollbars, i.e. the caret can end up "out-of-view".

There were problems in the ChUI editor, too - abends on edge cases when delete/backspace was used.

#3 - 05/10/2015 10:33 AM - Constantin Asofiei

- File ca_upd20150510d.zip added

New version: fixed 2 editor regressions and some other GUI improvements (FILL-IN colors, LABEL font, IMAGE size).

#4 - 05/10/2015 02:28 PM - Constantin Asofiei

ca_upd20150510d.zip has passed runtime testing.  But there might be more problematic edge cases (like merging lines on backspace/delete,

inserting chars on empty lines, etc) which are common to both ChUI and GUI versions.  This one can be released, but next phase should keep in

mind to check both ChUI and GUI for issues.
#5 - 05/10/2015 03:07 PM - Constantin Asofiei

Eugenie, can you review the ImageGuiImpl change in 0510d.zip? I wonder if you had a specific reason to return width/height 0 if image is not loaded.

#6 - 05/10/2015 05:27 PM - Eugenie Lyzenko

Eugenie, can you review the ImageGuiImpl change in 0510d.zip? I wonder if you had a specific reason to return width/height 0 if image is not

loaded.

 

1. This was there when I have started to work on image support.

2. But I think it is reasonable because what to return if image is not here? We can not imagine the actual image size if we have no image. There are

many image options that needs actual size, i.e. stretch to fit, offset, size phrase. Also the button size can depend on the image actual size when

image is used to draw button. If the image is not loaded, nothing to draw, what is the alternative for width/height?

Imagine two situations:

1. We have no image and width/height == 0.

2. We have no image and width/height != 0(as possible with your changes).

In both cases there is certainly some kind of issue, either image file is not specified or image can not be loaded for some reasons(missing file for

example). These situations needs the user to react. So what is the better signal for trouble?

I have no only right answer here(and have no objection for your change). But I think it is not good to report any features(width/height) for the object

that does not exist.

#7 - 05/11/2015 02:53 AM - Constantin Asofiei

Eugenie Lyzenko wrote:

Imagine two situations:

1. We have no image and width/height == 0.

2. We have no image and width/height != 0(as possible with your changes).

 

OK, but as I saw with DEFINE IMAGE, if a file is not specified, then a size phrase is required - so I don't think the image can end up with no size. 

Please test what happens with the image's WIDTH/HEIGHT-CHARS/PIXELS attributes in these cases (image or size phrase).

04/29/2024 2/7



#8 - 05/11/2015 02:57 AM - Constantin Asofiei

- File ca_upd20150511a.zip added

Attached version was committed to bzr rev 10858 (just a header entry added to ImageGuiImpl, it was missing in 0510d.zip)

#9 - 05/11/2015 10:30 AM - Eugenie Lyzenko

Please test what happens with the image's WIDTH/HEIGHT-CHARS/PIXELS attributes in these cases (image or size phrase).

 

If no image file but size specified is not 0, 4GL consider this as "empty" image with given size. "empty" image means the space for image is allocating

but no image is drawn.

#10 - 06/12/2015 04:09 PM - Constantin Asofiei

Eugenie, new question: are you sure the button's DEFAULT attribute needs to be checked in FrameGuiImpl.processDefaultButton? Because pressing

ENTER in i widget invokes the button's trigger even if the button's DEFAULT attribute is false.

DEF BUTTON btn1.

DEF VAR i AS INT.

FORM i btn1 WITH FRAME f1 DEFAULT-BUTTON btn1.

ON 'choose':U OF btn1 IN FRAME f1

DO:

   MESSAGE "choose" btn1:DEFAULT IN FRAME f1.

   RETURN.

END.

UPDATE i btn1 WITH FRAME f1.

#11 - 06/12/2015 04:45 PM - Eugenie Lyzenko

Eugenie, new question: are you sure the button's DEFAULT attribute needs to be checked in FrameGuiImpl.processDefaultButton? Because

pressing ENTER in i widget invokes the button's trigger even if the button's DEFAULT attribute is false.

 

Yes, I was sure it is the correct because according to Progress ABL Reference book page 1531-1532:
...

If the DEFAULT attribute is TRUE, the specified button is a default button. To make the specified button the d

efault button for the frame, you must also set the frame’s DEFAULT-BUTTON attribute to the handle of the butto

n.

...

To make the specified button the default button for the frame or dialog box, you must also set the button’s DE

FAULT attribute to TRUE.

...

I think these quotations clearly declare this.    

But with your test it works differently, button's DEFAULT attribute is silently ignoring. Looks like the Progress bug or documentation miss. So we have

to decide what strategy we will take here.

#12 - 06/16/2015 11:29 AM - Greg Shah

Looks like the Progress bug or documentation miss. So we have to decide what strategy we will take here.

 

It doesn't matter what the documentation says.  We have found the documentation to be very poor and often incorrect and/or incomplete.  This

behavior is something we must fix.  It will take some additional testcases to confirm the relationship (if any) between the BUTTON:DEFAULT and

FRAME DEFAULT-BUTTON option.  I've created a new task for this: #2588.

#13 - 06/17/2015 02:28 PM - Constantin Asofiei

I've added the EDITOR changes (and some scroll-related changes from #2546 - rev 10880) to the 2563b branch (rev 10881).  What it covers:

undo/redo on CTRL-Z

scrolling via keys/mouse

selection (added support for CTRL-SHIFT  keys, too)

WORD-WRAP/RETURN-INSERTED/MAX-CHARS attributes

copy/paste/cut

navigation: page-up/down, ctrl-left/right, ctrl-home/end

special keys: ctrl-del (delete to end of line), ctrl-enter (can be used even if RETURN-INSERTED is false)

#14 - 06/17/2015 03:44 PM - Greg Shah

Code Review  2563b branch (rev 10881)
This is a really good update.  I don't have any concerns.

#15 - 06/18/2015 08:19 AM - Constantin Asofiei

branch 2563b/rev 10882: Fixed javadoc errors.  Added mouse-double-click support.  Fixed scrolling by mouse and other caret-positioning problems.

No known issues at this point.  One more round of testing to confirm that it passes and it's good to go (once Eugenie releases his scroll changes).

#16 - 06/18/2015 04:12 PM - Constantin Asofiei

branch 2563b/rev 10882 passed testing

#17 - 06/19/2015 05:54 AM - Constantin Asofiei

rebased branch 2563b, new revision is 10884

#18 - 06/19/2015 10:51 AM - Greg Shah

Code Review Task Branch 2563b revision 10884

I like the changes, nice improvement.

Hynek's changes will need to be merged.  I know you are waiting on Eugenie's to pass and be checked in and then will merge those.  My only

question is whether you want to go before or after Igor's #2534 changes?

#19 - 06/19/2015 11:08 AM - Eugenie Lyzenko

Greg Shah wrote:

... I know you are waiting on Eugenie's to pass and be checked in and then will merge those...

 

I have already checked in and distributed the 0617b Scrollbar related update. It is required more actions from my side for Constantin to continue

working? Are we changing the updates release schema? I just need to know what exactly I have to do to do everything in a right way.

#20 - 06/19/2015 12:34 PM - Greg Shah

I have already checked in and distributed the 0617b Scrollbar related update.

 

Right, sorry.

It is required more actions from my side for Constantin to continue working?

 

No.

Are we changing the updates release schema?
Yes, but you don't have to make any changes right now.  We are testing a new process that uses branching instead of update zip files.  In the next

week or two we will roll it out to the entire company.

#21 - 06/19/2015 01:41 PM - Constantin Asofiei

Greg Shah wrote:

My only question is whether you want to go before or after Igor's #2534 changes?

 

I'd like to go after him, it will be easier to do the merge (as it affects the Editor classes).

#22 - 06/29/2015 04:21 AM - Constantin Asofiei

Rebased task branch 2563b from P2J trunk revision 10888 (new branch revision 10892).

#23 - 07/01/2015 04:56 AM - Constantin Asofiei

Rebased task branch 2563b from P2J trunk revision 10892 (new branch revision 10896).

#24 - 07/02/2015 07:06 AM - Constantin Asofiei

Rebased task branch 2563b from P2J trunk revision 10893 (new branch revision 10897).

#25 - 07/07/2015 11:25 AM - Constantin Asofiei

Rebased task branch 2563b from P2J trunk revision 10894 (new branch revision 10898).

#26 - 07/13/2015 11:59 AM - Constantin Asofiei

Rebased task branch 2563b from P2J trunk revision 10895 (new branch revision 10899).

There is a compile problem, need to change Igor's Editor.java change in #2534 (rev 10895) to work with the new impl.

#27 - 07/14/2015 03:41 PM - Constantin Asofiei

Please review task branch 2563b, revision 10903.

Revision 10901 is currently in runtime testing.  Revisions 10902/10903 have only GUI changes.

#28 - 07/14/2015 04:52 PM - Greg Shah

Code Review Task Branch 2563b, Revision 10903

I'm fine with the changes.  If it passes testing, please merge/commit to trunk.

#29 - 07/17/2015 05:01 AM - Constantin Asofiei

Please review task branch 2563b, revision 10907.
I'm running regression testing one more time, to clear some false negatives.  I'll merge/commit to trunk once it finishes.

#30 - 07/17/2015 06:22 AM - Greg Shah

Code Review Task Branch 2563b, Revision 10907

I'm fine with the changes. If it passes testing, please merge/commit to trunk.

#31 - 07/17/2015 11:36 AM - Constantin Asofiei

Branch 2563b was merged to trunk as revno 10896 then it was archived.

#32 - 07/17/2015 11:43 AM - Greg Shah

- Status changed from WIP to Closed

#33 - 11/16/2016 12:13 PM - Greg Shah

- Target version changed from Milestone 12 to GUI Support for a Complex ADM2 App

Files

ca_upd20150509b.zip 171 KB 05/09/2015 Constantin Asofiei

ca_upd20150510d.zip 186 KB 05/10/2015 Constantin Asofiei

ca_upd20150511a.zip 187 KB 05/11/2015 Constantin Asofiei
